3 # This is generic shell library for all the scripts used by Girocco;
4 # most importantly, it introduces all the $cfg_* shell variables.
7 octet
='[0-9a-f][0-9a-f]'
8 octet4
="$octet$octet$octet$octet"
9 octet19
="$octet4$octet4$octet4$octet4$octet$octet$octet"
10 octet20
="$octet4$octet4$octet4$octet4$octet4"
11 nullsha
="0000000000000000000000000000000000000000"
15 # set a sane umask that never excludes any user or group permissions
16 umask $
(printf '0%03o' $
(( $
(umask) & ~
0770 )) )
19 # Compare $1 to $2 each of which must match \d+(\.\d+)*
20 # An empty string ('') for $1 or $2 is treated like 0
25 # Note that `vcmp 1.8 1.8.0.0.0.0` correctly outputs 0.
29 [ -n "$_a" -o -n "$_b" ]
31 if [ "${_a:-0}" -lt "${_b:-0}" ]; then
34 elif [ "${_a:-0}" -gt "${_b:-0}" ]; then
40 set -- "${_a2#.}" "${_b2#.}"
46 get_girocco_config_pm_var_list
() (
47 # Export all the variables from Girocco::Config to suitable var= lines
48 # prefixing them with 'cfg_'. E.g. $cfg_admin is admin's mail address now
49 # and also setting a 'defined_cfg_' prefix to 1 if they are not undef.
50 __girocco_conf
="$GIROCCO_CONF"
51 [ -n "$__girocco_conf" ] || __girocco_conf
="Girocco::Config"
52 [ -z "$basedir" ] || __girocco_extrainc
="-I$basedir"
53 [ -z "$orig_path" ] ||
{ PATH
="$orig_path" && export PATH
; }
54 perl
-I@basedir@
$__girocco_extrainc -M$__girocco_conf -le \
55 'foreach (sort {uc($a) cmp uc($b)} keys %Girocco::Config::) {
56 my $val = ${$Girocco::Config::{$_}}; defined($val) or $val="";
57 $val =~ s/([\\"\$\`])/\\$1/gos;
58 $val =~ s/(?:\r\n|\r|\n)$//os;
59 print "cfg_$_=\"$val\"";
60 print "defined_cfg_$_=",
61 (defined(${$Girocco::Config::{$_}})?"1":"");
65 # Returns full command path for "$1" if it's a valid command otherwise returns "$1"
67 if _fp
="$(command -v "$1" 2>/dev/null)"; then
74 get_girocco_config_var_list
() (
75 # Same as get_girocco_config_pm_var_list except that
76 # the following variables (all starting with var_) are added:
77 # var_group cfg_owning_group if defined otherwise `id -gn`
78 # var_git_ver The version number part from `git version`
79 # var_git_exec_path The result of $cfg_git_bin --exec-dir
80 # var_sh_bin Full path to the posix sh interpreter to use
81 # var_perl_bin Full path to the perl interpreter to use
82 # var_gzip_bin Full path to the gzip executable to use
83 # var_nc_openbsd_bin Full path to the netcat (nc) with -U support
84 # var_have_git_171 Set to 1 if git version >= 1.7.1 otherwise ''
85 # var_have_git_172 Set to 1 if git version >= 1.7.2 otherwise ''
86 # var_have_git_173 Set to 1 if git version >= 1.7.3 otherwise ''
87 # var_have_git_1710 Set to 1 if git version >= 1.7.10 otherwise ''
88 # var_have_git_185 Set to 1 if git version >= 1.8.5 otherwise ''
89 # var_window_memory Value to use for repack --window-memory=
90 # var_big_file_threshold Value to use for core.bigFileThreshold
91 # var_redelta_threshold Recompute deltas if no more than this many objs
92 # var_upload_window If not "", pack.window to use for upload-pack
93 # var_log_window_size Value to use for git-svn --log-window-size=
94 # var_utf8_locale Value to use for a UTF-8 locale if available
95 # var_xargs_r A "-r" if xargs needs it to behave correctly
96 # var_du_exclude Option to exclude PATTERN from du if available
97 # var_du_follow Option to follow command line sym links if available
98 _cfg_vars
="$(get_girocco_config_pm_var_list)"
100 printf '%s\n' "$_cfg_vars"
101 printf 'var_group=%s\n' "${cfg_owning_group:-$(id -gn)}"
102 _gver
="$("$cfg_git_bin" version 2>/dev/null | \
103 LC_ALL=C sed -ne 's/^[^0-9]*\([0-9][0-9]*\(\.[0-9][0-9]*\)*\).*$/\1/p')"
104 printf 'var_git_ver=%s\n' "$_gver"
105 printf 'var_git_exec_path="%s"\n' "$("$cfg_git_bin" --exec-path 2>/dev/null)"
106 printf 'var_sh_bin="%s"\n' "$(_fcp "${cfg_posix_sh_bin:-/bin/sh}")"
107 printf 'var_perl_bin="%s"\n' "$(_fcp "${cfg_perl_bin:-$(unset -f perl; command -v perl)}")"
108 printf 'var_gzip_bin="%s"\n' "$(_fcp "${cfg_gzip_bin:-$(unset -f gzip; command -v gzip)}")"
109 printf 'var_nc_openbsd_bin="%s"\n' "$(_fcp "${cfg_nc_openbsd_bin:-$(unset -f nc; command -v nc)}")"
110 printf 'var_have_git_171=%s\n' "$([ $(vcmp "$_gver" 1.7.1) -ge 0 ] && echo 1)"
111 printf 'var_have_git_172=%s\n' "$([ $(vcmp "$_gver" 1.7.2) -ge 0 ] && echo 1)"
112 printf 'var_have_git_173=%s\n' "$([ $(vcmp "$_gver" 1.7.3) -ge 0 ] && echo 1)"
113 printf 'var_have_git_1710=%s\n' "$([ $(vcmp "$_gver" 1.7.10) -ge 0 ] && echo 1)"
114 printf 'var_have_git_185=%s\n' "$([ $(vcmp "$_gver" 1.8.5) -ge 0 ] && echo 1)"
115 __girocco_conf
="$GIROCCO_CONF"
116 [ -n "$__girocco_conf" ] || __girocco_conf
="Girocco::Config"
117 [ -z "$basedir" ] || __girocco_extrainc
="-I$basedir"
118 printf "var_window_memory=%s\n" \
119 "$(perl -I@basedir@ $__girocco_extrainc -M$__girocco_conf \
120 -MGirocco::Util -e 'print calc_windowmemory')"
121 printf "var_big_file_threshold=%s\n" \
122 "$(perl -I@basedir@ $__girocco_extrainc -M$__girocco_conf \
123 -MGirocco::Util -e 'print calc_bigfilethreshold')"
124 printf "var_redelta_threshold=%s\n" \
125 "$(perl -I@basedir@ $__girocco_extrainc -M$__girocco_conf \
126 -MGirocco::Util -e 'print calc_redeltathreshold')"
127 if [ -n "$cfg_upload_pack_window" ] && [ "$cfg_upload_pack_window" -ge 2 ] && \
128 [ "$cfg_upload_pack_window" -le 50 ]; then
129 printf "var_upload_window=%s\n" "$cfg_upload_pack_window"
131 printf "var_upload_window=%s\n" ""
133 printf 'var_log_window_size=%s\n' "${cfg_svn_log_window_size:-250}"
134 # We parse the output of `locale -a` and select a suitable UTF-8 locale.
135 _guess_locale
="$(locale -a | LC_ALL=C grep -viE '^(posix|c)(\..*)?$' | \
136 LC_ALL=C grep -iE '\.utf-?8$' | LC_ALL=C sed -e 's/\.[Uu][Tt][Ff]-*8$//' | \
137 LC_ALL=C sed -e '/en_US/ s/^/0 /; /en_US/ !s/^/1 /' | LC_ALL=C sort | \
138 head -n 1 | LC_ALL=C cut -d ' ' -f 2)"
139 [ -z "$_guess_locale" ] ||
printf 'var_utf8_locale=%s.UTF-8\n' "$_guess_locale"
140 # On some broken platforms running xargs without -r and empty input runs the command
141 printf 'var_xargs_r=%s\n' "$(: | command xargs echo -r)"
142 # The disk usage report produces better numbers if du has an exclude option
143 _x0
="$(basename "$0")"
145 for _duopt
in --exclude -I; do
146 if _test
="$(du $_duopt 's?lib.s*' $_duopt "$_x0" "$0" 2>/dev/null)" && [ -z "$_test" ]; then
147 printf 'var_du_exclude=%s\n' "$_duopt"
151 if _test
="$(du -H "$0" 2>/dev/null)" && [ -n "$_test" ]; then
152 printf 'var_du_follow=%s\n' "-H"
157 # If basedir has been replaced, and shlib_vars.sh exists, get the config
158 # definitions from it rather than running Perl.
159 if [ "@basedir@" = '@'basedir
'@' ] ||
! [ -r "@basedir@/shlib_vars.sh" ]; then
160 # Import all the variables from Girocco::Config to the local environment,
161 eval "$(get_girocco_config_var_list)"
163 # Import the variables from shlib_vars.sh which avoids needlessly
164 # running another copy of Perl
165 .
"@basedir@/shlib_vars.sh"
168 # git_add_config "some.var=value"
169 # every ' in value must be replaced with the 4-character sequence '\'' before
170 # calling this function or Git will barf. Will not be effective unless running
171 # Git version 1.7.3 or later.
173 GIT_CONFIG_PARAMETERS
="${GIT_CONFIG_PARAMETERS:+$GIT_CONFIG_PARAMETERS }'$1'"
174 export GIT_CONFIG_PARAMETERS
177 # Make sure we have a reproducible environment by using a controlled HOME dir
178 XDG_CONFIG_HOME
="$cfg_chroot/var/empty"
179 HOME
="$cfg_chroot/etc/girocco"
181 GIT_CONFIG_NOSYSTEM
=1
183 GIT_NO_REPLACE_OBJECTS
=1
184 GIT_TERMINAL_PROMPT
=0
185 GIT_ASKPASS
="$cfg_basedir/bin/git-askpass-password"
186 export XDG_CONFIG_HOME
189 export GIT_CONFIG_NOSYSTEM
190 export GIT_ATTR_NOSYSTEM
191 export GIT_NO_REPLACE_OBJECTS
192 export GIT_TERMINAL_PROMPT
195 unset GIT_HTTP_USER_AGENT
196 if [ -n "$defined_cfg_git_client_ua" ]; then
197 GIT_USER_AGENT
="$cfg_git_client_ua"
198 export GIT_USER_AGENT
199 GIT_HTTP_USER_AGENT
="$cfg_git_client_ua"
200 export GIT_HTTP_USER_AGENT
202 unset GIT_CONFIG_PARAMETERS
203 git_add_config
"core.ignoreCase=false"
204 if [ -n "$cfg_git_no_mmap" ]; then
205 # Just like compiling with NO_MMAP
206 git_add_config
"core.packedGitWindowSize=1m"
208 # Always use the 32-bit default (32m) even on 64-bit to avoid memory blowout
209 git_add_config
"core.packedGitWindowSize=32m"
211 [ -z "$var_big_file_threshold" ] ||
212 git_add_config
"core.bigFileThreshold=$var_big_file_threshold"
214 # Make sure any sendmail.pl config is always available
215 unset SENDMAIL_PL_HOST
216 unset SENDMAIL_PL_PORT
217 unset SENDMAIL_PL_NCBIN
218 unset SENDMAIL_PL_NCOPT
219 [ -z "$cfg_sendmail_pl_host" ] ||
{ SENDMAIL_PL_HOST
="$cfg_sendmail_pl_host" && export SENDMAIL_PL_HOST
; }
220 [ -z "$cfg_sendmail_pl_port" ] ||
{ SENDMAIL_PL_PORT
="$cfg_sendmail_pl_port" && export SENDMAIL_PL_PORT
; }
221 [ -z "$cfg_sendmail_pl_ncbin" ] ||
{ SENDMAIL_PL_NCBIN
="$cfg_sendmail_pl_ncbin" && export SENDMAIL_PL_NCBIN
; }
222 [ -z "$cfg_sendmail_pl_ncopt" ] ||
{ SENDMAIL_PL_NCOPT
="$cfg_sendmail_pl_ncopt" && export SENDMAIL_PL_NCOPT
; }
224 # Set PATH and PYTHON to the values set by Config.pm, if any
226 [ -z "$cfg_python" ] ||
{ PYTHON
="$cfg_python" && export PYTHON
; }
227 [ -z "$cfg_path" ] ||
{ orig_path
="$PATH" && PATH
="$cfg_path" && export PATH
; }
229 # Extra GIT variables that generally ought to be cleared, but whose clearing
230 # could potentially interfere with the correct operation of hook scripts so
231 # they are segregated into a separate function for use as appropriate
233 unset GIT_ALTERNATE_OBJECT_DIRECTORIES
238 unset GIT_OBJECT_DIRECTORY
242 # We cannot use a git() {} or nc_openbsd() {} function to redirect git
243 # and nc_openbsd to the desired executables because when using
244 # "ENV_VAR=xxx func" the various /bin/sh implementations behave in various
245 # different and unexpected ways:
246 # a) treat "ENV_VAR=xxx" like a separate, preceding "export ENV_VAR=xxx"
247 # b) treat "ENV_VAR=xxx" like a separate, prededing "ENV_VAR=xxx"
248 # c) treat "ENV_VAR=xxx" like a temporary setting only while running func
249 # None of these are good. We want a temporary "export ENV_VAR=xxx"
250 # setting only while running func which none of the /bin/sh's do.
252 # Instead we'd like to use an alias that provides the desired behavior without
253 # any of the bad (a), (b) or (c) effects.
255 # However, unfortunately, some of the crazy /bin/sh implementations do not
256 # recognize alias expansions when preceded by variable assignments!
258 # So we are left with git() {} and nc_openbsd() {} functions and in the
259 # case of git() {} we can compensate for (b) and (c) failing to export
260 # but not (a) and (b) persisting the values so the caller will simply
261 # have to beware and explicitly unset any variables that should not persist
262 # beyond the function call itself.
265 [ "${GIT_DIR+set}" = "set" ] && export GIT_DIR
266 [ "${GIT_SSL_NO_VERIFY+set}" = "set" ] && export GIT_SSL_NO_VERIFY
267 [ "${GIT_TRACE_PACKET+set}" = "set" ] && export GIT_TRACE_PACKET
268 [ "${GIT_USER_AGENT+set}" = "set" ] && export GIT_USER_AGENT
269 [ "${GIT_HTTP_USER_AGENT+set}" = "set" ] && export GIT_HTTP_USER_AGENT
270 exec "$cfg_git_bin" "$@"
273 # Since we do not yet require at least Git 1.8.5 this is a compatibility function
274 # that allows us to use git update-ref --stdin where supported and the slow shell
275 # script where not, but only the "delete" operation is currently supported.
276 git_updateref_stdin
() {
277 if [ -n "$var_have_git_185" ]; then
278 git update-ref
--stdin
280 while read -r _op _ref
; do
283 git update-ref
-d "$_ref"
286 echo "bad git_updateref_stdin op: $_op" >&2
294 # see comments for git() -- callers must explicitly export all variables
295 # intended for the commands these functions run before calling them
296 perl
() { command "${var_perl_bin:-perl}" "$@"; }
297 gzip() { command "${var_gzip_bin:-gzip}" "$@"; }
299 nc_openbsd
() { command "$var_nc_openbsd_bin" "$@"; }
301 list_packs
() { command "$cfg_basedir/bin/list_packs" "$@"; }
303 strftime
() { command "$cfg_basedir/bin/strftime" "$@"; }
305 # Some platforms' broken xargs runs the command always at least once even if
306 # there's no input unless given a special option. Automatically supply the
307 # option on those platforms by providing an xargs function.
308 xargs() { command xargs $var_xargs_r "$@"; }
312 for _addr
in "$@"; do
313 [ -z "$_list" ] || _list
="$_list, "
320 _mailer
="${cfg_sendmail_bin:-/usr/sbin/sendmail}"
321 if [ -n "$cfg_sender" ]; then
322 "$_mailer" -i -f "$cfg_sender" "$@"
330 if [ "$1" = "-s" ]; then
336 echo "From: \"$cfg_name\" ($cfg_title) <$cfg_admin>"
337 echo "To: $(_addrlist "$@
")"
338 [ -z "$_subject" ] ||
echo "Subject: $_subject"
339 echo "MIME-Version: 1.0"
340 echo "Content-Type: text/plain; charset=utf-8"
341 echo "Content-Transfer-Encoding: 8bit"
342 [ -n "$cfg_suppress_x_girocco" ] ||
echo "X-Girocco: $cfg_gitweburl"
343 echo "Auto-Submitted: auto-generated"
349 # bang CMD... will execute the command with well-defined failure mode;
350 # set bang_action to string of the failed action ('clone', 'update', ...);
351 # re-define the bang_trap() function to do custom cleanup before bailing out
356 if [ -n "$show_progress" ]; then
358 read -r bang_errcode
<<-EOT || :
360 exec 4>&3 3>&1 1>&4 4>&-
361 { "$@" 3>&- || echo $? >&3; } 2>&1 | tee -i -a "$bang_log"
365 if [ -z "$bang_errcode" ] ||
[ "$bang_errcode" = "0" ]; then
372 if "$@" >>"$bang_log" 2>&1; then
388 cat "$bang_log" > .banglog
390 echo "$bang_cmd failed with error code $bang_errcode" >> .banglog
391 if [ -n "$show_progress" ]; then
393 echo "$bang_cmd failed with error code $bang_errcode"
395 if [ -e .bangagain
]; then
396 git config
--remove-section girocco.bang
2>/dev
/null ||
:
399 bangcount
="$(git config --int girocco.bang.count 2>/dev/null || :)"
401 bangcount
=$
(( $bangcount + 1 ))
402 git config
--int girocco.bang.count
$bangcount
403 if [ $bangcount -eq 1 ]; then
404 git config girocco.bang.firstfail
"$(TZ=UTC date "+%Y-
%m-
%d
%T UTC
")"
406 if [ $bangcount -ge $cfg_min_mirror_failure_message_count ] && \
407 [ "$(git config --bool girocco.bang.messagesent 2>/dev/null || :)" != "true" ] && \
408 ! check_interval
"girocco.bang.firstfail" $cfg_min_mirror_failure_message_interval; then
409 bangmailok
="$(git config --bool gitweb.statusupdates 2>/dev/null || echo true)"
411 [ "$bangmailok" = "false" -o -z "$mail" ] || bangaddrs
="$mail"
412 [ -z "$cfg_admincc" -o "$cfg_admincc" = "0" -o -z "$cfg_admin" ] ||
413 if [ -z "$bangaddrs" ]; then bangaddrs
="$cfg_admin"; else bangaddrs
="$bangaddrs,$cfg_admin"; fi
415 [ $bangcount -le 1 ] || rsubj
=" repeatedly"
416 [ -z "$bangaddrs" ] ||
418 echo "$bang_cmd failed with error code $bang_errcode"
421 if [ $bangcount -gt 1 ]; then
422 echo "$bangcount consecutive update failures have occurred since $(config_get girocco.bang.firstfail)"
425 echo "you will not receive any more notifications until recovery"
426 echo "this status message may be disabled on the project admin page"
431 } |
mail -s "[$cfg_name] $proj $bang_action failed$rsubj" "$bangaddrs"
432 git config
--bool girocco.bang.messagesent true
435 [ $bangcount -lt 15 ] || \
436 check_interval
"girocco.bang.firstfail" $
(( $cfg_min_mirror_interval * 3 / 2 )) || \
438 bang_trap
$bangthrottle
439 [ -n "$bang_errcode" ] && [ "$bang_errcode" != "0" ] || bang_errcode
=1
443 # bang_eval CMD... will evaluate the command with well-defined failure mode;
444 # Identical to bang CMD... except the command is eval'd instead of executed.
449 # Default bang settings:
452 bang_action
="lame_programmer"
454 bang_log
="$(mktemp -t repomgr-XXXXXX)"
456 echo "bang_setup called with current directory not a git directory" >&2
459 trap 'rm -f "$bang_log"' EXIT
460 trap '[ -z "$bang_active" ] || { bang_errcode=130; bang_failed; }; exit 130' INT
461 trap '[ -z "$bang_active" ] || { bang_errcode=143; bang_failed; }; exit 143' TERM
464 # Remove banged status
466 rm -f .banged .bangagain .banglog
467 git config
--remove-section girocco.bang
2>/dev
/null ||
:
470 # Check to see if banged status
475 # Check to see if banged message was sent
476 was_banged_message_sent
() {
477 [ "$(git config --bool girocco.bang.messagesent 2>/dev/null || :)" = "true" ]
480 # Progress report - if show_progress is set, shows the given message.
482 [ ! -n "$show_progress" ] ||
echo "$@"
485 # Project config accessors; must be run in project directory
491 git config
"gitweb.$1";;
496 git config
"gitweb.$1" "$2" && chgrp
$var_group config
&& chmod g
+w config
500 git config
"$1" "$2" && chgrp
$var_group config
&& chmod g
+w config
503 config_get_date_seconds
() {
504 _dt
="$(config_get "$1" || :)"
505 [ -n "$_dt" ] ||
return 1
506 _ds
="$(perl -I@basedir@ -MGirocco::Util -e "print parse_any_date
('$_dt')")"
507 [ -n "$_ds" ] ||
return 1
511 # Tool for checking whether given number of seconds has not passed yet
513 os
="$(config_get_date_seconds "$1")" ||
return 1
515 [ $ns -lt $
(($os+$2)) ]
518 # Check if we are running with effective root permissions
520 [ "$(id -u 2>/dev/null)" = "0" ]
523 # Check to see if the single argument is a Git directory
525 # Just like Git's test except we ignore GIT_OBJECT_DIRECTORY
526 # And we are slightly more picky (must be refs/.+ not refs/.*)
527 [ -d "$1/objects" -a -x "$1/objects" ] ||
return 1
528 [ -d "$1/refs" -a -x "$1/refs" ] ||
return 1
529 if [ -L "$1/HEAD" ]; then
530 _hr
="$(readlink "$1/HEAD
")"
531 case "$_hr" in "refs/"?
*) :;; *) return 1;; esac
533 [ -f "$1/HEAD" -a -r "$1/HEAD" ] ||
return 1
534 read -r _hr
<"$1/HEAD" ||
return 1
536 $octet20 | ref
:refs
/?
*)
539 _hr
="${_hr##ref:*[ $tab]}"
540 case "$_hr" in "refs/"?
*) return 0;; esac
545 # List all Git repositories, with given prefix if specified, one-per-line
546 # All project names starting with _ are always excluded from the result
549 LC_ALL
=C cut
-d : -f 1,3 "$cfg_chroot"/etc
/group | LC_ALL
=C
grep "^$1"
551 LC_ALL
=C cut
-d : -f 1,3 "$cfg_chroot"/etc
/group
552 fi |
while IFS
=: read name id
; do
553 [ $id -lt 65536 ] ||
case "$name" in _
*) :;; ?
*) echo "$name"; esac
557 # Return success if the given project name has any forks
560 [ -n "$_prj" ] ||
return 1
561 [ -d "$cfg_reporoot/$_prj" ] ||
return 1
562 is_git_dir
"$cfg_reporoot/$_prj.git" ||
return 1
563 test $
(get_repo_list
"$_prj/[^/][^/]*:" | LC_ALL
=C
wc -l) -gt 0
566 # returns empty string and error for empty string otherwise one of
567 # m => normal Git mirror
568 # s => mirror from svn source
569 # d => mirror from darcs source
570 # b => mirror from bzr source
571 # h => mirror from hg source
572 # w => mirror from mediawiki source
573 # f => mirror from other fast-import source
574 # note that if the string is non-empty and none of s, d, b or h match the
575 # return will always be type m regardless of whether it's a valid Git URL
576 get_url_mirror_type
() {
581 svn
://* | svn
+http
://* | svn
+https
://* | svn
+file://* | svn
+ssh://*)
590 hg
+http
://* | hg
+https
://* | hg
+file://* | hg
+ssh://* | hg
::*)
603 # returns false for empty string
604 # returns true if the passed in url is a mirror using git fast-import
605 is_gfi_mirror_url
() {
606 [ -n "$1" ] ||
return 1
607 case "$(get_url_mirror_type "$1" 2>/dev/null || :)" in
609 # darcs, bzr, hg and mediawiki mirrors use git fast-import
610 # and so do generic "f" fast-import mirrors
614 # Don't think git-svn currently uses git fast-import
615 # And Git mirrors certainly do not
619 # assume it does not use git fast-import
623 # returns false for empty string
624 # returns true if the passed in url is a mirror using git-svn
625 is_svn_mirror_url
() {
626 [ -n "$1" ] ||
return 1
627 [ "$(get_url_mirror_type "$1" 2>/dev/null || :)" = "s" ]
630 # returns mirror url for gitweb.baseurl of git directory
631 # (GIT_DIR) passed in as the argument (which defaults to "." if omitted)
632 # will fail if the directory does not have .nofetch and gitweb.baseurl
633 # comes back empty -- otherwise .nofetch directories succeed with a "" return
634 # automatically strips any leading "disabled " prefix before returning result
637 # always return empty for non-mirrors
638 [ ! -e "$_gitdir/.nofetch" ] ||
return 0
639 _url
="$(GIT_DIR="$_gitdir" config_get baseurl 2>/dev/null || :)"
641 [ -n "$_url" ] ||
return 1
642 printf '%s\n' "$_url"
646 # returns get_url_mirror_type for gitweb.baseurl of git directory
647 # (GIT_DIR) passed in as the argument (which defaults to "." if omitted)
648 # will fail if the directory does not have .nofetch and gitweb.baseurl
649 # comes back empty -- otherwise .nofetch directories succeed with a "" return
650 # automatically strips any leading "disabled " prefix before testing
652 _url
="$(get_mirror_url "$@
")" ||
return 1
653 get_url_mirror_type
"$_url"
656 # returns true if the passed in git dir (defaults to ".") is a mirror using git fast-import
658 _url
="$(get_mirror_url "$@
")" ||
return 1
659 is_gfi_mirror_url
"$_url"
662 # returns true if the passed in git dir (defaults to ".") is a mirror using git-svn
664 _url
="$(get_mirror_url "$@
")" ||
return 1
665 is_svn_mirror_url
"$_url"
668 # current directory must already be set to Git repository
669 # if girocco.headok is already true succeeds without doing anything
670 # if rev-parse --verify HEAD succeeds sets headok=true and succeeds
671 # otherwise tries to set HEAD to a symbolic ref to refs/heads/master
672 # then refs/heads/trunk and finally the first top-level head from
673 # refs/heads/* (i.e. only two slashes in the name) and finally any
674 # existing refs/heads. The first one to succeed wins and sets headok=true
675 # and then a successful exit. Otherwise headok is left unset with a failure exit
676 # We use the girocco.headok flag to make sure we only force a valid HEAD symref
677 # when the repository is being set up -- if the HEAD is later deleted (through
678 # a push or fetch --prune) that's no longer our responsibility to fix
679 check_and_set_head
() {
680 [ "$(git config --bool girocco.headok 2>/dev/null || :)" != "true" ] ||
return 0
681 if git rev-parse
--verify --quiet HEAD
>/dev
/null
; then
682 git config
--bool girocco.headok true
685 for _hr
in refs
/heads
/master refs
/heads
/trunk
; do
686 if git rev-parse
--verify --quiet "$_hr"; then
687 _update_head_symref
"$_hr"
691 git for-each-ref
--format="%(refname)" refs
/heads
2>/dev
/null |
692 while read -r _hr
; do
693 case "${_hr#refs/heads/}" in */*) :;; *)
694 _update_head_symref
"$_hr"
695 exit 1 # exit subshell created by "|"
698 _hr
="$(git for-each-ref --format="%(refname
)" refs/heads 2>/dev/null | head -n 1 || :)"
699 if [ -n "$_hr" ]; then
700 _update_head_symref
"$_hr"
705 _update_head_symref
() {
706 git symbolic-ref HEAD
"$1"
707 git config
--bool girocco.headok true
708 ! [ -d htmlcache
] ||
{ >htmlcache
/changed
; } 2>/dev
/null ||
:
711 # A well-known UTF-8 locale is required for some of the fast-import providers
712 # in order to avoid mangling characters. Ideally we could use "POSIX.UTF-8"
713 # but that is not reliably UTF-8 but rather usually US-ASCII.
714 # We parse the output of `locale -a` and select a suitable UTF-8 locale at
715 # install time and store that in $var_utf8_locale if one is found.
716 # If we cannot find one in the `locale -a` output then we just use a well-known
717 # UTF-8 locale and hope for the best. We set LC_ALL to our choice and export
718 # it. We only set this temporarily when running the fast-import providers.
720 LC_ALL
="${var_utf8_locale:-en_US.UTF-8}"
724 # hg-fast-export | git fast-import with error handling in current directory GIT_DIR
727 _python
="${PYTHON:-python}"
728 rm -f hg2git-marks.old hg2git-marks.new
729 if [ -f hg2git-marks
-a -s hg2git-marks
]; then
730 LC_ALL
=C
sed 's/^:\([^ ][^ ]*\) \([^ ][^ ]*\)$/\2 \1/' <hg2git-marks |
{
731 if [ -n "$var_have_git_185" ]; then
732 git cat-file
--batch-check=':%(rest) %(objectname)'
734 LC_ALL
=C
sed 's/^\([^ ][^ ]*\) \([^ ][^ ]*\)$/:\2 \1/'
736 } | LC_ALL
=C
sed '/ missing$/d' >hg2git-marks.old
737 if [ -n "$var_have_git_171" ] && \
738 git rev-parse
--quiet --verify refs
/notes
/hg
>/dev
/null
; then
739 if [ -z "$var_have_git_185" ] || \
740 ! LC_ALL
=C
cmp -s hg2git-marks hg2git-marks.old
; then
742 GIT_AUTHOR_NAME
="$_nm"
743 GIT_COMMITTER_NAME
="$_nm"
744 GIT_AUTHOR_EMAIL
="$_nm"
745 GIT_COMMITTER_EMAIL
="$_nm"
746 export GIT_AUTHOR_NAME
747 export GIT_COMMITTER_NAME
748 export GIT_AUTHOR_EMAIL
749 export GIT_COMMITTER_EMAIL
750 git notes
--ref=refs
/notes
/hg prune
751 unset GIT_AUTHOR_NAME
752 unset GIT_COMMITTER_NAME
753 unset GIT_AUTHOR_EMAIL
754 unset GIT_COMMITTER_EMAIL
763 { read -r _err1 ||
:; read -r _err2 ||
:; } <<-EOT
765 exec 4>&3 3>&1 1>&4 4>&-
768 _af="$(git config hg.authorsfile || :)"
769 _cmd='GIT_DIR="$(pwd)" "$_python" "$cfg_basedir/bin/hg-fast-export.py" \
770 --repo "$(pwd)/repo.hg" \
771 --marks "$(pwd)/hg2git-marks.old" \
772 --mapping "$(pwd)/hg2git-mapping" \
773 --heads "$(pwd)/hg2git-heads" \
774 --status "$(pwd)/hg2git-state" \
775 -U unknown --force --flatten --hg-hash'
776 [ -z "$_af" ] || _cmd="$_cmd"' --authors "$_af"'
777 eval "$_cmd" 3>&- || _e1=$?
783 --import-marks="$(pwd)/hg2git-marks.old" \
784 --export-marks="$(pwd)/hg2git-marks.new" \
785 --export-pack-edges="$(pwd)/gfi-packs" \
786 --force 3>&- || _e2=$?
792 [ "$_err1" = 0 -a "$_err2" = 0 ] ||
return 1
793 mv -f hg2git-marks.new hg2git-marks
794 rm -f hg2git-marks.old
795 git for-each-ref
--format='%(refname) %(objectname)' refs
/heads | \
796 LC_ALL
=C
sed -e 's,^refs/heads/,:,' >hg2git-heads